From 0941dc231d61b029487d33d3bcb39b44cbb8e1aa Mon Sep 17 00:00:00 2001
From: sezero <sezero@users.sourceforge.net>
Date: Sun, 22 Jan 2017 11:20:20 +0300
Subject: [PATCH 7/9] lpc.c: provide a solution for missing lround() for Watcom

---
 src/libFLAC/lpc.c | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

diff --git a/src/libFLAC/lpc.c b/src/libFLAC/lpc.c
index a624c93..e99f567 100644
--- a/src/libFLAC/lpc.c
+++ b/src/libFLAC/lpc.c
@@ -60,6 +60,20 @@ static inline long int lround(double x) {
 static inline long int lround(double x) {
 	return (long)(x + __builtin_copysign(0.5, x));
 }
+#elif defined __WATCOMC__
+extern long lrint(double);
+#pragma aux lrint = \
+    "push  eax" \
+    "fistp qword ptr [esp]" \
+    "pop   eax" \
+    parm [8087] \
+    value [eax] \
+    modify exact [eax];
+long lround(double x) {
+   x = (x >= 0)? floor(x + 0.5) : ceil(x - 0.5);
+   return lrint(x);
+}
+#else
 /* If this fails, we are in the presence of a mid 90's compiler, move along... */
 #endif
 
-- 
1.8.5.5

